searchNodes=[{"doc":"This is an in-memory ring buffer backend for the Elixir Logger.Install it by adding it to your config.exs:use Mix.Config # Add the RingLogger backend. This removes the # default :console backend. config :logger, backends: [RingLogger] # Set the number of messages to hold in the circular buffer config :logger, RingLogger, max_size: 1024Or add manually:Logger.add_backend(RingLogger) Logger.configure_backend(RingLogger, max_size: 1024)Once added as a backend, you have two options depending on whether you're accessing the RingLogger via the IEx prompt or via code. If you're at the IEx prompt, use the helper methods in here like attach, detach, next, tail, grep, etc. They'll automate a few things behind the scenes. If you're writing a program that needs to get log messages, use get or start_link a RingLogger.Client and call its methods directly.","ref":"RingLogger.html","title":"RingLogger","type":"module"},{"doc":"Attach the current IEx session to the logger. It will start printing log messages.Options include::io - output location when printing. Defaults to :stdio:colors - a keyword list of coloring options:metadata - a keyword list of additional metadata:format - the format message used to print logs:level - the minimum log level to report by this backend. Note that the :logger application's :level setting filters log messages prior to RingLogger.:module_levels - a map of log level overrides per module. For example, %{MyModule =&gt; :error, MyOtherModule =&gt; :none}:application_levels - a map of log level overrides per application. For example, %{:my_app =&gt; :error, :my_other_app =&gt; :none}. Note log levels set in :module_levels will take precedence.","ref":"RingLogger.html#attach/1","title":"RingLogger.attach/1","type":"function"},{"doc":"Fetch the current configuration for the attached client","ref":"RingLogger.html#config/0","title":"RingLogger.config/0","type":"function"},{"doc":"Update the logger configuration.Options include::max_size - the max number of log messages to store at a time","ref":"RingLogger.html#configure/1","title":"RingLogger.configure/1","type":"function"},{"doc":"Detach the current IEx session from the logger.","ref":"RingLogger.html#detach/0","title":"RingLogger.detach/0","type":"function"},{"doc":"Helper method for formatting log messages per the current client's configuration.","ref":"RingLogger.html#format/1","title":"RingLogger.format/1","type":"function"},{"doc":"Get n log messages starting at the specified index.Set n to 0 to get entries to the end","ref":"RingLogger.html#get/2","title":"RingLogger.get/2","type":"function"},{"doc":"Run a regular expression on each entry in the log and print out the matchers.For example:iex&gt; RingLogger.grep(~r/something/) :ok Options include:Options from attach/1:pager - a function for printing log messages to the console. Defaults to IO.binwrite/2.","ref":"RingLogger.html#grep/2","title":"RingLogger.grep/2","type":"function"},{"doc":"Print the next messages in the log.Options include:Options from attach/1:pager - a function for printing log messages to the console. Defaults to IO.binwrite/2.","ref":"RingLogger.html#next/1","title":"RingLogger.next/1","type":"function"},{"doc":"Reset the index into the log for next/1 to the oldest entry.","ref":"RingLogger.html#reset/1","title":"RingLogger.reset/1","type":"function"},{"doc":"Save the contents of the log to the specified pathThe file is overwritten if it already exists. Log message formatting is done similarly to other RingLogger calls.","ref":"RingLogger.html#save/1","title":"RingLogger.save/1","type":"function"},{"doc":"Print the last n messages in the log.Options include:Options from attach/1:pager - a function for printing log messages to the console. Defaults to IO.binwrite/2.","ref":"RingLogger.html#tail/0","title":"RingLogger.tail/0","type":"function"},{"doc":"","ref":"RingLogger.html#tail/1","title":"RingLogger.tail/1","type":"function"},{"doc":"","ref":"RingLogger.html#tail/2","title":"RingLogger.tail/2","type":"function"},{"doc":"Option values used by client-side functions like attach and tail","ref":"RingLogger.html#t:client_option/0","title":"RingLogger.client_option/0","type":"type"},{"doc":"A tuple holding a raw, unformatted log entry","ref":"RingLogger.html#t:entry/0","title":"RingLogger.entry/0","type":"type"},{"doc":"Callback function for printing/paging tail, grep, and next output","ref":"RingLogger.html#t:pager_fun/0","title":"RingLogger.pager_fun/0","type":"type"},{"doc":"Option values used by the ring logger","ref":"RingLogger.html#t:server_option/0","title":"RingLogger.server_option/0","type":"type"},{"doc":"Helper module for RingLogger.Client to simplify IEx useIf you're a human, call these functions via RingLogger.*. If you're a program, call RingLogger.Client.start_link/1 to start your own client and call it directly.","ref":"RingLogger.Autoclient.html","title":"RingLogger.Autoclient","type":"module"},{"doc":"Attach to the logger and print messages as they come in.","ref":"RingLogger.Autoclient.html#attach/1","title":"RingLogger.Autoclient.attach/1","type":"function"},{"doc":"Fetch the current configuration for the attached client.","ref":"RingLogger.Autoclient.html#config/0","title":"RingLogger.Autoclient.config/0","type":"function"},{"doc":"Detach from the logger. Log messages will stop being printed to the console.","ref":"RingLogger.Autoclient.html#detach/0","title":"RingLogger.Autoclient.detach/0","type":"function"},{"doc":"Completely stop the RingLogger.Client. You normally don't need to run this.","ref":"RingLogger.Autoclient.html#forget/0","title":"RingLogger.Autoclient.forget/0","type":"function"},{"doc":"Format a log message. This is useful if you're calling RingLogger.get/1 directly.","ref":"RingLogger.Autoclient.html#format/1","title":"RingLogger.Autoclient.format/1","type":"function"},{"doc":"Run a regular expression on each entry in the log and print out the matchers.","ref":"RingLogger.Autoclient.html#grep/2","title":"RingLogger.Autoclient.grep/2","type":"function"},{"doc":"Print the log messages since the previous time this was called.","ref":"RingLogger.Autoclient.html#next/1","title":"RingLogger.Autoclient.next/1","type":"function"},{"doc":"Reset the index used to keep track of the position in the log for tail/1 so that the next call to tail/1 starts back at the oldest entry.","ref":"RingLogger.Autoclient.html#reset/1","title":"RingLogger.Autoclient.reset/1","type":"function"},{"doc":"Save the log.","ref":"RingLogger.Autoclient.html#save/1","title":"RingLogger.Autoclient.save/1","type":"function"},{"doc":"Print the most recent log messages.","ref":"RingLogger.Autoclient.html#tail/2","title":"RingLogger.Autoclient.tail/2","type":"function"},{"doc":"Circular BufferThis is a modified version of https://github.com/keathley/circular_buffer that doesn't use :queue. It creates less garbage than the :queue version and is slightly faster in trivial benchmarks. RingLogger currently has other limitations that make it hard to see these improvements.When creating a circular buffer you must specify the max size:cb = CircularBuffer.new(10)","ref":"RingLogger.CircularBuffer.html","title":"RingLogger.CircularBuffer","type":"module"},{"doc":"Checks the buffer to see if its emptyRuns in constant time","ref":"RingLogger.CircularBuffer.html#empty?/1","title":"RingLogger.CircularBuffer.empty?/1","type":"function"},{"doc":"Inserts a new item into the next location of the circular bufferAmortized run time: O(1) Worst case run time: O(n)","ref":"RingLogger.CircularBuffer.html#insert/2","title":"RingLogger.CircularBuffer.insert/2","type":"function"},{"doc":"Creates a new circular buffer with a given size.","ref":"RingLogger.CircularBuffer.html#new/1","title":"RingLogger.CircularBuffer.new/1","type":"function"},{"doc":"Returns the newest element in the bufferRuns in constant time.","ref":"RingLogger.CircularBuffer.html#newest/1","title":"RingLogger.CircularBuffer.newest/1","type":"function"},{"doc":"Returns the oldest element in the bufferMostly runs in constant time. Worst case O(n).","ref":"RingLogger.CircularBuffer.html#oldest/1","title":"RingLogger.CircularBuffer.oldest/1","type":"function"},{"doc":"Converts a circular buffer to a list.The list is ordered from oldest to newest elements based on their insertion order.Worst case run time: O(n)","ref":"RingLogger.CircularBuffer.html#to_list/1","title":"RingLogger.CircularBuffer.to_list/1","type":"function"},{"doc":"Interact with the RingLogger","ref":"RingLogger.Client.html","title":"RingLogger.Client","type":"module"},{"doc":"Attach the current IEx session to the logger. It will start printing log messages.","ref":"RingLogger.Client.html#attach/1","title":"RingLogger.Client.attach/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"RingLogger.Client.html#child_spec/1","title":"RingLogger.Client.child_spec/1","type":"function"},{"doc":"Fetch the current client configuration.","ref":"RingLogger.Client.html#config/1","title":"RingLogger.Client.config/1","type":"function"},{"doc":"Update the client configuration.Options include::io - Defaults to :stdio:colors -:metadata - A KV list of additional metadata:format - A custom format string, or a {module, function} tuple (see https://hexdocs.pm/logger/master/Logger.html#module-custom-formatting):level - The minimum log level to report.:module_levels - a map of log level overrides per module. For example, %{MyModule =&gt; :error, MyOtherModule =&gt; :none}:application_levels - a map of log level overrides per application. For example, %{:my_app =&gt; :error, :my_other_app =&gt; :none}. Note log levels set in :module_levels will take precedence.","ref":"RingLogger.Client.html#configure/2","title":"RingLogger.Client.configure/2","type":"function"},{"doc":"","ref":"RingLogger.Client.html#configure_module_levels/1","title":"RingLogger.Client.configure_module_levels/1","type":"function"},{"doc":"Detach the current IEx session from the logger.","ref":"RingLogger.Client.html#detach/1","title":"RingLogger.Client.detach/1","type":"function"},{"doc":"Helper method for formatting log messages per the current client's configuration.","ref":"RingLogger.Client.html#format/2","title":"RingLogger.Client.format/2","type":"function"},{"doc":"Run a regular expression on each entry in the log and print out the matchers.Supported options::pager - an optional 2-arity function that takes an IO device and what to print","ref":"RingLogger.Client.html#grep/3","title":"RingLogger.Client.grep/3","type":"function"},{"doc":"Get the next set of the messages in the log.Supported options::pager - an optional 2-arity function that takes an IO device and what to print","ref":"RingLogger.Client.html#next/2","title":"RingLogger.Client.next/2","type":"function"},{"doc":"Reset the index into the log for tail/1 to the oldest entry.","ref":"RingLogger.Client.html#reset/1","title":"RingLogger.Client.reset/1","type":"function"},{"doc":"Format and save all log messages to the specified path.","ref":"RingLogger.Client.html#save/2","title":"RingLogger.Client.save/2","type":"function"},{"doc":"Start up a client GenServer. Except for just getting the contents of the ring buffer, you'll need to create one of these. See configure/2 for information on options.","ref":"RingLogger.Client.html#start_link/1","title":"RingLogger.Client.start_link/1","type":"function"},{"doc":"Stop a client.","ref":"RingLogger.Client.html#stop/1","title":"RingLogger.Client.stop/1","type":"function"},{"doc":"Get the last n messages.Supported options::pager - an optional 2-arity function that takes an IO device and what to print","ref":"RingLogger.Client.html#tail/3","title":"RingLogger.Client.tail/3","type":"function"},{"doc":"ring_logger This is an in-memory ring buffer backend for the Elixir Logger with convenience methods for accessing the logs from the IEx prompt.Use cases:Get log messages in real-time over remote IEx sessionsGrep and tail through log messages without setting up anything elseKeep logs in limited resource environmentsCapture recent log events for error reportsAs a bonus, ring_logger is nice to your IEx prompt. If you attach to the log and are receiving messages as they're sent, they won't stomp what you're typing.","ref":"readme.html","title":"ring_logger","type":"extras"},{"doc":"Add ring_logger to your projects dependencies in your mix.exs: def deps do [{:ring_logger, &quot;~&gt; 0.6&quot;}] endThen configure the logger in your config/config.exs:use Mix.Config # Add the RingLogger backend. This removes the # default :console backend. config :logger, backends: [RingLogger] # Set the number of messages to hold in the circular buffer config :logger, RingLogger, max_size: 1024 # You can also configure RingLogger.Client options to be used # with every client by default config :ring_logger, application_levels: %{my_app: :error}, color: [debug: :yellow], level: :debugOr you can start the backend manually by running the following:Logger.add_backend(RingLogger) Logger.configure_backend(RingLogger, max_size: 1024)","ref":"readme.html#configuration","title":"ring_logger - Configuration","type":"extras"},{"doc":"See the example project for a hands-on walk-through of using the logger. Read on for the highlights.Log messages aren't printed to the console by default. If you're seeing them, they may be coming from Elixir's default :console logger.To see log messages as they come in, call RingLogger.attach() and then to make the log messages stop, call RingLogger.detach(). The attach method takes options if you want to limit the log level, change the formatting, etc.Here's an example:iex&gt; Logger.add_backend(RingLogger) {:ok, #PID&lt;0.199.0&gt;} iex&gt; Logger.remove_backend(:console) :ok iex&gt; RingLogger.attach :ok iex&gt; require Logger iex&gt; Logger.info(&quot;hello&quot;) :ok 14:04:52.516 [info] helloThis probably isn't too exciting until you see that it works on remote shells as well (the :console logger doesn't do this).Say you prefer polling for log messages rather than having them print over your console at random times. If you're still attached, then detach and next:iex&gt; RingLogger.detach :ok iex&gt; Logger.info(&quot;Hello logger, how are you?&quot;) :ok iex&gt; Logger.info(&quot;It&#39;s a nice day. Wouldn&#39;t you say?&quot;) :ok iex&gt; RingLogger.next 14:04:52.516 [info] hello 14:11:54.397 [info] Hello logger, how are you? 14:12:09.180 [info] It&#39;s a nice day. Wouldn&#39;t you say? :ok iex&gt; RingLogger.next :okIf you only want to see the most recent entries, run tail:iex&gt; RingLogger.tail 14:04:52.516 [info] hello 14:11:54.397 [info] Hello logger, how are you? 14:12:09.180 [info] It&#39;s a nice day. Wouldn&#39;t you say? :okYou can also grep:iex&gt; RingLogger.grep(~r/[Nn]eedle/) 16:55:41.614 [info] Needle in a haystack","ref":"readme.html#iex-session-usage","title":"ring_logger - IEx session usage","type":"extras"},{"doc":"If you want to filter a module or modules at a particular level you pass a map where the key is the module name and value in the level into the :module_levels option to RingLogger.attach/1.For example:iex&gt; RingLogger.attach(module_levels: %{MyModule =&gt; :info})This will ignore all the :debug messages from MyModule.Also, it allows for filtering the whole project on a higher level, but a particular module, or a subset of modules, to log at a lower level like so:iex&gt; RingLogger.attach(module_levels: %{MyModule =&gt; :debug}, level: :warn)In the example above log messages at the :debug level will be logged, but every other module will be logging at the :warn level. You can also turn off a module's logging completely by specifying :none.Additionally, you can specify the same options at the application level to disable logging for all its modules using the :application_levels option with OTP application names as the key:iex&gt; RingLogger.attach(application_levels: %{my_app: :info})module_levels takes precedence in the case of including both module and application level filtering:iex&gt; RingLogger.attach(application_levels: %{my_app: :info}, module_levels: %{MyApp.Important =&gt; :debug})In the above example, all modules of :my_app with have a level of :info except for MyApp.Important, which will have a level of :debug.As a note if the Elixir Logger level is set too low you will miss some log messages.","ref":"readme.html#module-and-application-level-filtering","title":"ring_logger - Module and Application Level Filtering","type":"extras"},{"doc":"By design, RingLogger doesn't save logs. It can be convenient to share the current log buffer for later analysis:iex&gt; RingLogger.save(&quot;/tmp/log.txt&quot;) :okLog messages are formatted the same way as the RingLogger functions that output to the console.","ref":"readme.html#saving-the-log","title":"ring_logger - Saving the log","type":"extras"},{"doc":"If you want to use a specific string format with the built in Elixir Logger.Formatter, you can pass that as the :format option to RingLogger.attach/1.If you want to use a custom formatter function, you can pass it through the :format option to RingLogger.attach/1 instead.For example, to print the file and line number of each log message, you could define a function as follows:defmodule CustomFormatter do def format(_level, message, _timestamp, metadata) do &quot;\#{message} \#{metadata[:file]}:\#{metadata[:line]}\\n&quot; rescue _ -&gt; message end endand attach to the RingLogger with:iex&gt; RingLogger.attach(format: {CustomFormatter, :format}, metadata: [:file, :line]) :ok iex&gt; require Logger Logger iex&gt; Logger.info(&quot;Important message!&quot;) :ok Important message! iex:4Within an application, the iex:4 would be the source file path and line number.See Logger custom formatting for more information.","ref":"readme.html#formatting","title":"ring_logger - Formatting","type":"extras"},{"doc":"It can be useful to get a snapshot of the log when an unexpected event occurs. The commandline functions demonstrated above are available, but you can also get the raw log entries by calling RingLogger.get/0:iex&gt; RingLogger.get [ debug: {Logger, &quot;8&quot;, {{2018, 2, 5}, {17, 44, 7, 675}}, [ pid: #PID&lt;0.139.0&gt;, application: :example, module: Example, function: &quot;log/1&quot;, file: &quot;ring_logger/example/lib/example.ex&quot;, line: 11 ]}, debug: {Logger, &quot;9&quot;, {{2018, 2, 5}, {17, 44, 8, 676}}, [ pid: #PID&lt;0.139.0&gt;, application: :example, module: Example, function: &quot;log/1&quot;, file: &quot;ring_logger/example/lib/example.ex&quot;, line: 11 ]}, debug: {Logger, &quot;10&quot;, {{2018, 2, 5}, {17, 44, 9, 677}}, [ pid: #PID&lt;0.139.0&gt;, application: :example, module: Example, function: &quot;log/1&quot;, file: &quot;ring_logger/example/lib/example.ex&quot;, line: 11 ]} ]","ref":"readme.html#programmatic-usage","title":"ring_logger - Programmatic usage","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"New featuresRingLogger.next/1 now outputs a summary line that says how many log messages were recented and how many were filtered. This makes it easier to identify when the ring buffer is being overtaken by filtered log entriesImprovementsSeveral internal refactorings were made to reduce memory usage and the number of reductions run in the RingLogger.Server GenServer. This makes a noticeable improvement when monitoring resource usage on a device.Improved tests to verify more edge conditions","ref":"changelog.html#v0-8-1","title":"Changelog - v0.8.1","type":"extras"},{"doc":"New featuresSupport filtering by OTP application. This uses the same mechanism as per-module filtering by automatically adding in all modules that are part of an OTP application. It is super useful! See the README.md. Thanks to Jon Carstons for adding this feature.Support setting defaults on RingLogger clients so that you can configure things like a global default to info level messages and then only show debug messages from some applications","ref":"changelog.html#v0-8-0","title":"Changelog - v0.8.0","type":"extras"},{"doc":"New featuresAdded save/1 to save the current set of log messages in the ring buffer to a file","ref":"changelog.html#v0-7-0","title":"Changelog - v0.7.0","type":"extras"},{"doc":"Bug fixesMake RingLogger.grep friendlier by supporting strings as arguments","ref":"changelog.html#v0-6-1","title":"Changelog - v0.6.1","type":"extras"},{"doc":"Important: RingLogger.tail is now RingLogger.next. RingLogger.tail shows the last n lines of the log (default is 10).New featuresgrep greps the whole log entry rather than just the message portion. You can grep on timestamps and message levels now.Functions that print log messages do the printing in the caller's context so that printing timeouts don't happen in RingLogger GenServers calls.Added :none as a per-module log level to completely silence a module.Added :pager option to specify a custom printer for the interactive commands.","ref":"changelog.html#v0-6-0","title":"Changelog - v0.6.0","type":"extras"},{"doc":"New featuresAdd support for changing the log levels on a per-module basis. Thanks to Matt Ludwigs for this change. See the README.md for details.Add a :format option to accept a custom format function similar to how Logger supports custom formatting. Thanks to Tim Mecklem for this.Bumped default ring buffer size from 100 messages to 1024.Bug fixesLog clients are now fully configurable. Previous versions inadvertantly limited the options that could be set.","ref":"changelog.html#v0-5-0","title":"Changelog - v0.5.0","type":"extras"},{"doc":"Bug fixesFix crash when grep'ing iodataFix init/1 callback return value when only specifying the module.","ref":"changelog.html#v0-4-1","title":"Changelog - v0.4.1","type":"extras"},{"doc":"New featuresAdded grepAutomatically add the backend if it's not running when using the IEx helpers","ref":"changelog.html#v0-4-0","title":"Changelog - v0.4.0","type":"extras"},{"doc":"Renamed LoggerCircularBuffer to RingLogger and made backwards incompatible API changes. Please review docs when upgrading.New featuresSimplified use from IEx by autostarting the Client GenServerAdded support for tailing logs","ref":"changelog.html#v0-3-0","title":"Changelog - v0.3.0","type":"extras"},{"doc":"Renamed LoggerCircularBuffer to LoggerCircularBuffer","ref":"changelog.html#v0-2-0","title":"Changelog - v0.2.0","type":"extras"},{"doc":"Initial release","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"}]